; functions.lsp

(defun remove-one (data obj)
    (let ((ans nil))
	(loop
	    (if (null obj) (return ans))
	    (if (equal data (car obj)) (return (append ans (cdr obj))))
	    (if (and (stringp data) (stringp (car obj)) (string-equal data (car obj))) (return (append ans (cdr obj))))
	    (setq ans (append ans (list (car obj))))
	    (setq obj (cdr obj)) ) ) )

(defun sort-one (obj test)
    (let ((koho (car obj))
	  (rest (cdr obj)))
	(loop
	    (if (null rest) (return koho))
	    (if (funcall test (car rest) koho) (setq koho (car rest)))
	    (setq rest (cdr rest)) ) ) )

; ֐SORT objtesťŃ\[g܂B
(defun sort (obj test)
    (let ((ans nil) (one))
	(loop
	    (if (null (cdr obj)) (return (append ans obj)))
	    (setq one (sort-one obj test))
	    (setq ans (append ans (list one)))
	    (setq obj (remove-one one obj)) ) ) )

; }NSETF
(defmacro setf (x? y?)
    (cond
	((symbolp x?) `(setq ,x? ,y?))
	((and (not (atom x?)) (eq (car x?) 'car) (not (atom (cdr x?))))
	 `(progn (rplaca ,(car (cdr x?)) ,y?) ,y?) )
	((and (not (atom x?)) (eq (car x?) 'cdr) (not (atom (cdr x?))))
	 `(progn (rplacd ,(car (cdr x?)) ,y?) ,y?) )
	((and (not (atom x?)) (eq (car x?) 'nth) (not (atom (cdr x?))) (not (atom (cdr (cdr x?)))))
	 `(progn (rplaca (nthcdr ,(car (cdr x?)) ,(car (cdr (cdr x?)))) ,y?) ,y?) )
	((and (not (atom x?)) (not (atom (cdr x?))) (find-nth-name (car x?)))
	 `(progn (rplaca (nthcdr ,(cdr (find-nth-name (car x?))) ,(car (cdr x?))) ,y?) ,y?) )
	((and (not (atom x?)) (not (atom (cdr x?))) (find-a-name (car x?)))
	 `(progn (rplaca ,(cons (cdr (find-a-name (car x?))) (cdr x?)) ,y?) ,y?) )
	((and (not (atom x?)) (not (atom (cdr x?))) (find-d-name (car x?)))
	 `(progn (rplacd ,(cons (cdr (find-d-name (car x?))) (cdr x?)) ,y?) ,y?) )
	((and (not (atom x?)) (eql (car x?) 'gethash) (not (atom (cdr x?))) (not (atom (cdr (cdr x?)))))
	 (let ((cnd?) (ins?) (inskep?) (previns?) (val? (eval y?)) (ky? (eval (car (cdr x?)))))
	    (setq ins? (eval (car (cdr (cdr x?)))))
	    (if (or (atom ins?) (not (eql (car ins?) 'hash-table)) (atom (cdr ins?)) (not (atom (setq cnd? (car (cdr ins?))))) )
		(progn
		    (print '(not hash-table))
		    nil
		)
		(progn
		    (setq inskep? ins?)
		    (setq previns? (cdr ins?))
		    (setq ins? (cdr (cdr ins?)))
		    (loop
			(if (null ins?) (return `(let () (rplacd ',previns? (list ',(cons ky? val?))) ',val?)))
			(if (atom (car ins?)) (progn (print '(hash-table is destoryed)) nil))
			(if (funcall cnd? ky? (car (car ins?))) (return `(let () (rplacd ',(car ins?) ',val?) ',val?)))
			(setq previns? ins?)
			(setq ins? (cdr ins?))
		    )
		)
	    )
	 )
	)
	((and (consp x?) (eql (car x?) 'aref))
;	 (list 'progn (list 'array-rplaca (cons 'pre-aref (cdr x?)) y?) y?) )
	 (list 'progn (list 'rplaca (cons 'pre-aref (cons y? (cdr x?))) y?) y?) )
	(t nil)
    )
)

(defun find-nth-name (name)
    (assoc name '((first . 0) (second . 1) (third . 2) (fourth . 3) (fifth . 4))) )

; ֐NTHCDR
(defun nthcdr (n lst)
    (cond
	((> 0 n) nil)
	((atom lst) lst)
	((zerop n) lst)
	(t (nthcdr (1- n) (cdr lst))) ) )

; ֐ASSOC
(defun assoc (x alist)
    (cond
	((atom alist) nil)
	((eq x (car (car alist))) (car alist))
	(t (assoc x (cdr alist))) ) )

(defun find-a-name (name)
    (assoc name '(
(caaaar . caaar) (caaadr . caadr) (caaar . caar) (caadar . cadar) (caaddr . caddr) (caadr . cadr) (caar . car)
(cadaar . cdaar) (cadadr . cdadr) (cadar . cdar) (caddar . cddar) (cadddr . cdddr) (caddr . cddr) (cadr . cdr)
    ) ) )

(defun find-d-name (name)
    (assoc name '(
(cdaaar . caaar) (cdaadr . caadr) (cdaar . caar) (cdadar . cadar) (cdaddr . caddr) (cdadr . cadr) (cdar . car)
(cddaar . cdaar) (cddadr . cdadr) (cddar . cdar) (cdddar . cddar) (cddddr . cdddr) (cdddr . cddr) (cddr . cdr)
    ) ) )

;----- hash-table functions---------------------------------------------------------------------------------------

(defun make-hash-table (&rest b)
    (cond
	((null b) (list 'hash-table 'eql))
	((eql (car b) :test) (list 'hash-table (car (cdr b))))
	(t (print '(syntax error)) nil) ) )

(defun gethash (key ins)
    (let ((cnd))
	(if (or (atom ins) (not (eql (car ins) 'hash-table)) (atom (cdr ins)) (not (atom (setq cnd (car (cdr ins))))) )
	    (progn
		(print '(not hash-table))
		nil
	    )
	    (progn
		(setq ins (cdr (cdr ins)))
		(loop
		    (if (null ins) (return (values nil nil)))
		    (if (atom (car ins)) (progn (print '(hash-table is destoryed)) nil))
		    (if (funcall cnd key (car (car ins))) (return (values (cdr (car ins)) t)))
		    (setq ins (cdr ins))
		)
	    )
	)
    )
)

(defun hash-table-count (ins)
    (if (or (atom ins) (not (eql (car ins) 'hash-table)) (atom (cdr ins)))
	(progn
	    (print '(not hash-table))
	    nil
	)
	(length (cdr (cdr ins)))
    )
)

(defun remhash (key ins)
    (if (or (atom ins) (not (eql (car ins) 'hash-table)) (atom (cdr ins)))
	(progn
	    (print '(not hash-table))
	    nil
	)
	(let ((previns) (test (car (cdr ins))))
	    (setq previns (cdr ins))
	    (setq ins (cdr (cdr ins)))
	    (loop
		(if (null ins) (return nil))
		(if (funcall test key (car (car ins)))
		    (progn
			(rplacd previns (cdr ins))
			(return t)
		    )
		)
		(setq previns ins)
		(setq ins (cdr ins))
	    )
	)
    )
)

(defun maphash (func hash)
    (setq hash (cdr (cdr hash)))
    (loop
	(if (null hash) (return nil))
	(funcall func (car (car hash)) (cdr (car hash)))
	(setq hash (cdr hash)) ) )

;-----------------------------------------------------------------------------------------------------------------
(defun caaaar (x) (car (caaar x)))

(defun caaadr (x) (car (caadr x)))

(defun caaar (x) (car (caar x)))

(defun caadar (x) (car (cadar x)))

(defun caaddr (x) (car (caddr x)))

(defun caadr (x) (car (cadr x)))

(defun caar (x) (car (car x)))

(defun cadaar (x) (car (cdaar x)))

(defun cadadr (x) (car (cdadr x)))

(defun cadar (x) (car (cdar x)))

(defun caddar (x) (car (cddar x)))

(defun cadddr (x) (car (cdddr x)))

(defun caddr (x) (car (cddr x)))

(defun cadr (x) (car (cdr x)))

;----------------------------------------------
(defun cdaaar (x) (cdr (caaar x)))

(defun cdaadr (x) (cdr (caadr x)))

(defun cdaar (x) (cdr (caar x)))

(defun cdadar (x) (cdr (cadar x)))

(defun cdaddr (x) (cdr (caddr x)))

(defun cdadr (x) (cdr (cadr x)))

(defun cdar (x) (cdr (car x)))

(defun cddaar (x) (cdr (cdaar x)))

(defun cddadr (x) (cdr (cdadr x)))

(defun cddar (x) (cdr (cdar x)))

(defun cdddar (x) (cdr (cddar x)))

(defun cddddr (x) (cdr (cdddr x)))

(defun cdddr (x) (cdr (cddr x)))

(defun cddr (x) (cdr (cdr x)))

;--------------------------------------------------

; ֐STRING/=
(defun string/= (x y)
    (let ((x1 (coerce x 'list))
	  (y1 (coerce y 'list)) )
	(string/=sub x1 y1 0) ) )

(defun string/=sub (x1 y1 n)
    (cond
	((and (null x1) (null y1)) nil)
	((null x1) n)
	((null y1) n)
	((eql (car x1) (car y1))
	 (string/=sub (cdr x1) (cdr y1) (1+ n)) )
	(t n) ) )

; ֐STRING=
(defun string= (x y) (string-equal x y))

; ֐STRING<
(defun string< (x y)
    (let ((x1 (coerce x 'list))
	  (y1 (coerce y 'list)) )
	(string<sub x1 y1 0) ) )

(defun string<sub (x1 y1 n)
    (cond
	((and (null x1) (null y1)) nil)
	((null x1) n)
	((null y1) nil)
	((char< (car x1) (car y1)) n)
	((char= (car x1) (car y1))
	 (string<sub (cdr x1) (cdr y1) (1+ n)) )
	(t nil) ) )

; ֐STRING<=
(defun string<= (x y)
    (let ((x1 (coerce x 'list))
	  (y1 (coerce y 'list)) )
	(string<=sub x1 y1 0) ) )

(defun string<=sub (x1 y1 n)
    (cond
	((and (null x1) (null y1)) n)
	((null x1) n)
	((null y1) nil)
	((char< (car x1) (car y1)) n)
	((char= (car x1) (car y1))
	 (string<=sub (cdr x1) (cdr y1) (1+ n)) )
	(t nil) ) )

; ֐STRING>
(defun string> (x y)
    (let ((x1 (coerce x 'list))
	  (y1 (coerce y 'list)) )
	(string>sub x1 y1 0) ) )

(defun string>sub (x1 y1 n)
    (cond
	((and (null x1) (null y1)) nil)
	((null x1) nil)
	((null y1) n)
	((char> (car x1) (car y1)) n)
	((char= (car x1) (car y1))
	 (string>sub (cdr x1) (cdr y1) (1+ n)) )
	(t nil) ) )

; ֐STRING>=
(defun string>= (x y)
    (let ((x1 (coerce x 'list))
	  (y1 (coerce y 'list)) )
	(string>=sub x1 y1 0) ) )

(defun string>=sub (x1 y1 n)
    (cond
	((and (null x1) (null y1)) n)
	((null x1) nil)
	((null y1) n)
	((char> (car x1) (car y1)) n)
	((char= (car x1) (car y1))
	 (string>=sub (cdr x1) (cdr y1) (1+ n)) )
	(t nil) ) )

; }NDO*
(defmacro do* (a b &rest c)
    `(prog ,(mapcar #'car a)
	   ,@(mapcar #'(lambda (x) (list 'setq (car x) (cadr x))) a)
        label
	   (if ,(car b) (return ,(if (null (cdr b)) nil (cadr b))))
	   ,@c
	   ,@(mapcar #'(lambda (x) (list 'setq (car x) (caddr x))) a)
	   (go label)
     ) )

; ֐LAST
(defun last (x)
    (cond
	((atom x) x)
	((= (length x) 1) x)
	(t (last (cdr x))) ) )

; ֐FLOOR
; x͐
(defun floor (x &rest y)
    (cond
	((null y) (setq y 1))
	(t (setq y (car y))) )
    (if (< x y) (values 0 x)
	(multiple-value-bind (q r) (floor (- x y) y)
	    (values (+ q 1) r))))

; }NCASE
(defmacro case (key &rest body)
    `(cond
	,@(make-case key body) ) )

(defun make-case (key body)
    (cond
	((null body) nil)
	((eq (car (car body)) 'otherwise) (cons `(t ,@(cdr (car  body))) (make-case key (cdr body))))
	((atom (car (car body))) (cons `((eql ,key ',(car (car body))) ,@(cdr (car body))) (make-case key (cdr body))))
	(t (cons `((member ,key ',(car (car body))) ,@(cdr (car body))) (make-case key (cdr body)))) ) )
